-- for some reason, when joining a listen server (NOT dedicated!),
-- the client starts ticking the game before its players have actually been added to the game

-- displayplayers is all zero during this limbo time, and if there is more than
-- one player (i.e. splitscreen), then displayplayers.iterate loops forever

-- fix this by wrapping displayplayers and bailing if dp 0 and 1 are identical (this should normally never happen AFAIK)
-- this triggers an error if displayplayers.iterate() is used (notice the parentheses),
-- but i dunno how to detect if it's a function call

-- this breaks #displayplayers btw. __len doesn't work for tables in lua 5.1

local realdisplayplayers = displayplayers

rawset(_G, "displayplayers", setmetatable(
	{},
	{
		__index = function(_, k)
			if k == "iterate" then
				if realdisplayplayers[0] and realdisplayplayers[0] == realdisplayplayers[1] then
					--print("Dodging displayplayers freeze")
					return function() return nil end -- don't iterate
				end
				return realdisplayplayers.iterate
			else return realdisplayplayers[k] end
		end
	}
))
