-- Credits to NVJR for this lua (Freeman#7626?)
-- Fixed so it no longer immediately kills you in f-zero when SPB attacking
-- ... and it wasn't netsynched. Very cool.
if(fzero_fix_applied and fzero_fix_applied == true)
then
    print("fzero_fix already loaded")
    return
end
print("Loading fzero_fix")
rawset(_G, "fzero_fix_applied", true)

local STARTTIME = 7*TICRATE

-- note: load after any other mods that affect spb speed to prevent conflicts
local do_fzero_speed = nil
addHook("MapLoad", function ()
    if mapheaderinfo[gamemap] and mapheaderinfo[gamemap].fzero and mapheaderinfo[gamemap].fzerospeed then
        do_fzero_speed = max(FRACUNIT, mapheaderinfo[gamemap].fzerospeed*FRACUNIT/100)
    else
        do_fzero_speed = nil
    end
end)

addHook("MobjThinker", function(spb)
    if(do_fzero_speed and leveltime > STARTTIME) then
        -- I shall spare you in the air
        if(spb.tracer and P_IsObjectOnGround(spb.tracer)) then
            spb.momx = FixedMul($, do_fzero_speed)
            spb.momy = FixedMul($, do_fzero_speed)
            spb.momz = FixedMul($, do_fzero_speed)
        end
    end end, MT_SPB)


addHook("MobjThinker", function(jawz)
    if(do_fzero_speed and leveltime > STARTTIME) then
		jawz.momx = FixedMul($, do_fzero_speed)
		jawz.momy = FixedMul($, do_fzero_speed)
    end end, MT_JAWZ)

addHook("NetVars", function(net)
    do_fzero_speed = net($)
end)
