-- Spinoutbumpfix by Indev for Sunflower's garden
-- An attempt to fix bug where when you bump into person whose spinout timer *just* run out game
-- treats them as they were in normal state standing so you completely lose your speed. Problem is
-- assumed that at the moment spinout timer runs out, i.frames don't get applied for 1 tic
local cv_bumpspinoutfix = CV_RegisterVar {
    name = "bumpspinoutfix",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
}

addHook("PlayerThink", function(p)
    if cv_bumpspinoutfix.value == 0 then return end

    local spin = max(p.kartstuff[k_spinouttimer], p.kartstuff[k_wipeoutslow])

    if spin ~= 0 and spin <= 2 then
        p.bumpspinoutfix = 4
    end

    if p.bumpspinoutfix then p.bumpspinoutfix = max(0, $ - 1) end
end)

local function bump(pmo, mo)
    if not (mo.valid and pmo.valid) then return end
    if cv_bumpspinoutfix.value == 0 then return end
    if not mo.player then return end

    if pmo.player.bumpspinoutfix then return false end
end

addHook("MobjCollide", bump, MT_PLAYER)
addHook("MobjMoveCollide", bump, MT_PLAYER)
