-- Reverts respawn back to vanilla instead of KMP's buggy, exploitable one (https://mb.srb2.org/threads/1-5-kartmp-a-hot-take-on-kart-balance.28021/page-2#post-554563)
-- Credits to Indev
COM_AddCommand("respawn", function(p)
    if not (gamestate == GS_LEVEL or gamestate == GS_INTERMISSION or gamestate == GS_VOTING) then
        CONS_Printf(p, "You must be in a level to use this.")
        return
    end

    if p.mo and not P_IsObjectOnGround(p.mo) then
        CONS_Printf(p, "You must be on the floor to use this.");
        return
    end

    if p.mo and (p.kartstuff[k_spinouttimer] or spbplace == p.kartstuff[k_position]) or p.targeted_by_jawz then
        CONS_Printf(p, "Nice try.")
        return
    end

    if p.mo then
        P_DamageMobj(p.mo, nil, nil, 10000)
    end
end)

addHook("PreThinkFrame", function()
    for player in players.iterate do
        player.targeted_by_jawz = false
    end
end)

addHook("MobjThinker", function(mo)
    if mo.tracer and mo.tracer.valid and mo.tracer.player and mo.tracer.player.valid then
        mo.tracer.player.targeted_by_jawz = true
    end
end, MT_JAWZ)